/* This is a *very* draft hack of xkbvleds and asmodem */
/* for switch Thai-English Keyboard */
#include <signal.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/XKBlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Box.h>
#include <stdio.h>
#include <string.h>
#include <X11/extensions/shape.h>
#include <X11/xpm.h>
#include "XPM/ws.xpm"

#define SEALEVEL 20
#define LEFTSPACE 10
#define FONT "-*-helvetica-medium-r-normal-*-*-*-*-*-*-*-*-*"

XFontStruct* font;
FILE * thefile;
char thebuff[100];
Display *inDpy,*outDpy;
static	unsigned long	wanted,real,named,explicit,automatic,virtual;
static	char *	inDpyName;
int	evBase,errBase;
int tag;
Bool	synch;
Bool	useUnion= True;
int zz,aa;
XEvent Event;            

void exitonerror(int c){
	exit(-1);
}


Display * GetDisplay(char * program,char * dpyName){
int		mjr,mnr,error;
Window		topWin;
Display	*	dpy;

    mjr= XkbMajorVersion;
    mnr= XkbMinorVersion;
    dpy= XkbOpenDisplay(dpyName,&evBase,&errBase,&mjr,&mnr,&error);
    if (dpy==NULL) {
	switch (error) {
	    case XkbOD_BadLibraryVersion:
		break;
	    case XkbOD_ConnectionRefused:
		break;
	    case XkbOD_NonXkbServer:
		break;
	    case XkbOD_BadServerVersion:
		break;
	    default:
	}
    }
    else if (synch)
	XSynchronize(dpy,True);
    return dpy;
}

typedef struct _XpmIcon {
	Pixmap pixmap;
	Pixmap mask;
	XpmAttributes attributes;
} XpmIcon;

XpmIcon WS;

int	CheckMailBox(char *Mbox);
int	IsNewMail(char *Mbox);
int	IsMail(char *Mbox);
void	Help(void);
void	CreateWindow(Display *);
void	MainLoop();
void	GetXPM();
void	RedrawWindow( XpmIcon *v);
static void	redraw_watch();
Pixel	GetColor(char *name);

Display	*Disp;	 
Window	Root;
Window	Iconwin;
Window	Win;
char	*Geometry= 0;
int	hicolor=0;
GC	WinGC;
GC	NGC;

void CreateWindow(Display * Disp){
	int i;
	unsigned int borderwidth ;
	char *wname = "watchswap";
	XGCValues gcv;
	unsigned long gcm;
	XTextProperty name;
	Pixel back_pix, fore_pix;
	Pixmap pixmask;
	int screen;	
	int x_fd;
	int d_depth;
	int ScreenWidth, ScreenHeight;
	XSizeHints SizeHints;
	XWMHints WmHints;
        XClassHint classHint;   
	
	screen = DefaultScreen(Disp);
	Root = RootWindow(Disp, screen);
	d_depth = DefaultDepth(Disp, screen);
	x_fd = XConnectionNumber(Disp);	
	ScreenHeight = DisplayHeight(Disp,screen);
	ScreenWidth = DisplayWidth(Disp,screen);
	       
	GetXPM();
		
	SizeHints.flags= USSize|USPosition;
	SizeHints.x = 0;
	SizeHints.y = 0;	
	back_pix = GetColor("red");
	fore_pix = GetColor("blue");
	XWMGeometry(Disp, screen, Geometry, NULL, (borderwidth =1), &SizeHints,
		    &SizeHints.x,&SizeHints.y,&SizeHints.width,
		    &SizeHints.height, &i); 	
	SizeHints.width = WS.attributes.width;
	SizeHints.height= WS.attributes.height;	
	Win = XCreateSimpleWindow(Disp,Root,SizeHints.x,SizeHints.y,
				  SizeHints.width,SizeHints.height,
				  borderwidth,fore_pix,back_pix); 
	Iconwin = XCreateSimpleWindow(Disp,Win,SizeHints.x,SizeHints.y,
				      SizeHints.width,SizeHints.height,
				      borderwidth,fore_pix,back_pix);	     

	classHint.res_name =  "watchswap";
        classHint.res_class = "Watchswap";
        XSetClassHint(Disp, Win, &classHint);     

	XSetWMNormalHints(Disp, Win, &SizeHints);
	XSelectInput(Disp, Win, (ExposureMask | ButtonPressMask | 
				 StructureNotifyMask));
	XSelectInput(Disp, Iconwin, (ExposureMask | ButtonPressMask | 
				     StructureNotifyMask));
	if (XStringListToTextProperty(&wname, 1, &name) ==0) 
	{
		fprintf(stderr, "watchswap: can't allocate window name\n");
		exit(-1);
	}
	XSetWMName(Disp, Win, &name);
	
	/* Create WinGC */
	gcm = GCForeground|GCBackground|GCGraphicsExposures;
	gcv.foreground = fore_pix;
	gcv.background = back_pix;
	gcv.graphics_exposures = True;
	WinGC = XCreateGC(Disp, Root, gcm, &gcv);  


        WmHints.initial_state = WithdrawnState;

        WmHints.window_group = Win;
        WmHints.flags = StateHint | IconWindowHint | IconPositionHint
          | WindowGroupHint;

	WmHints.icon_window = Iconwin;
	WmHints.icon_x = SizeHints.x;
	WmHints.icon_y = SizeHints.y;
	XSetWMHints(Disp, Win, &WmHints); 	
	XMapWindow(Disp,Win);
}

void GetXPM()
{
	char **ws;
	XWindowAttributes Attributes;
	int Ret;


        ws=ws_xpm;

	
	XGetWindowAttributes(Disp,Root,&Attributes);		
	WS.attributes.valuemask |= (XpmReturnPixels | XpmReturnExtensions);

	Ret = XpmCreatePixmapFromData(Disp, Root, ws_xpm, &WS.pixmap, 
				      &WS.mask, &WS.attributes);

	if(Ret != XpmSuccess)
	{
		fprintf(stderr, "watchswap: not enough free color cells\n");
		exit(1);
	}

}

static void redraw_watch(){
	if(tag){
        RedrawWindow(&WS);
	}
	signal(SIGALRM,redraw_watch);
	alarm(1);
}

void RedrawWindow(XpmIcon *Icon)
{		
	long int b;
	char *seeker;
	char print[20];

    thefile=fopen("/proc/meminfo","r");
	fgets(thebuff,80,thefile);
	fgets(thebuff,80,thefile);
	fgets(thebuff,80,thefile);
/*	sscanf(thebuff,"%s %s %d %s",0,0,&b,0);*/
	for(seeker=thebuff+6;*seeker!=' ';seeker++);
	for(seeker++;*seeker==' ';seeker++);
	b=atoi(seeker);
	sprintf(print,"%d.%dMB",b/1048576,(b/104857)%10);
	b=XTextWidth(font,print,strlen(print));
	XShapeCombineMask(Disp, Win, ShapeBounding, 0, 0, 
			  Icon->mask, ShapeSet);
	XShapeCombineMask(Disp, Iconwin, ShapeBounding, 0, 0, 
				  Icon->mask, ShapeSet);

	XSetClipOrigin(Disp,WinGC,0,0);
	XSetClipMask(Disp,WinGC,Icon->mask);
	
	XCopyArea(Disp,Icon->pixmap,Win,WinGC,
		  0,0,Icon->attributes.width, Icon->attributes.height,0,0);
	XCopyArea(Disp,Icon->pixmap,Iconwin,WinGC,
		  0,0,Icon->attributes.width, Icon->attributes.height,0,0);
	XDrawString(inDpy, Iconwin, WinGC,(64-b)/2,SEALEVEL,print,strlen(print));
	XFlush(Disp);
	fclose(thefile);
}

Pixel GetColor(char *ColorName) {
	XColor Color;
	XWindowAttributes Attributes;
	
	XGetWindowAttributes(Disp,Root,&Attributes);
	Color.pixel = 0;
	
	if (!XParseColor (Disp, Attributes.colormap, ColorName, &Color)) 
		fprintf(stderr,"watchswap: can't parse %s\n", ColorName);
	else if(!XAllocColor (Disp, Attributes.colormap, &Color)) 
		fprintf(stderr,"watchswap: can't allocate %s\n", ColorName);       
	
	return Color.pixel;
}

int main(int argc, char **argv) {

Widget		toplevel, session;
XtAppContext	app_con;
unsigned	i;
unsigned	bitmask;
unsigned	n;
XkbDescPtr	xkb;
XkbEvent	ev;
static char *	fallback_resources[] = {
    "*Box*background: grey40",
    NULL
};

    toplevel = XtOpenApplication(&app_con, "Nonlock", NULL, 0, &argc, argv, 
				 fallback_resources,
				 sessionShellWidgetClass, NULL, ZERO);
    if (toplevel==NULL) {
	return 1;
    }
    inDpy= XtDisplay(toplevel);
    Disp=inDpy;
    CreateWindow(inDpy);
    XSetCommand(Disp,Win,argv,argc); 
    font=XLoadQueryFont(inDpy,FONT);
    XSetFont(inDpy,WinGC,font->fid);
    XSetForeground(inDpy,WinGC,-1);
    signal(SIGALRM,redraw_watch);
    alarm(1);
    for(;;) {
	    tag=1;
           XNextEvent(inDpy,&Event);
	   tag=0;
           switch(Event.type){                    
               case NoExpose:
                        break;
               case Expose:           /* Redraw window */
			if(Event.xexpose.count == 0)
                        RedrawWindow(&WS);
                        break;               
               case DestroyNotify:    /* Destroy window */
                     XFreeGC(inDpy, WinGC);
                     XFreeGC(inDpy, NGC);
                     XDestroyWindow(inDpy, Win);
                     XDestroyWindow(inDpy, Iconwin);
                     XCloseDisplay(inDpy);                            
                     exit(0);
                     break;                  
           }

    }

BAIL:
    XCloseDisplay(inDpy);
    inDpy= NULL;
    return 0;
}
